<?php

require_once "../libs/vendor/autoload.php";

class facturaPDF
{
    // * Variables globales para mPDF
    public $mpdf;
    public $htmlFile;
    public $renderHTML;

    // * Variables globales para SendGrid
    public $email;
    // Subrutina para generar el reporte con los datos del $response[]
    public function generarFacturaPDF($params)
    {
        // ! Establece la zona horaria por defecto.
        date_default_timezone_set('America/Guatemala');

        // ! Creación de fecha y hora
        $fechaHora = date("Y-m-d-H-i-s");

        // ! Ajuste de parametros
        // * Matriz $detalleVentas para recorrer
        $datFact = $params['datFac'];
    	$detVenta = $params['detVenta'];
    
    	
        // * Variables a asignar el Detalle de Venta
        $sku = "";
    	$precio = "";
        $nombre = "";
        $cant = "";
        $total = "";
    	$Empresa = "";

        foreach ($detVenta as $index => $value) {
            if (is_array($value)) {
                foreach ($value as $key => $values) {
                   //echo $key . " : " . $values . "<br>";
                    if ($key == "DescCorta") {
                        $nombre .= $values  . '<br>';
                    }
                	if ($key == "PrecioUnitario") {
                        $precio .= "Q " . $values  . '<br>';
                    }
                    if ($key == "Cantidad") {
                        $cant .= $values  . '<br>';
                    }
                    if ($key == "Total") {
                        $total .= "Q " . $values  . '<br>';
                    }
                }
            }
        }
    
    /*
        foreach ($datFact as $index => $value) {
        	echo $index . " : " . $value . "<br>";
         	if ($index == "Empresa") {
                  $Empresa .= $value  . '<br>';
         	}
        }
        
     */

    
    	//Tipo transaccion
    	if ($datFact['tipoTransaccion'] == "0"){
        	$datFact['tipoAfiliacion'] = "RECIBO";
        	$datFact['leyendaFEL'] = "";
        }    
        // ! MPDF
        // * Crea una instancia de la clase Mpdf:
        $this->mpdf = new \Mpdf\Mpdf();

        $this->renderHTML_test = "
            <!DOCTYPE html>
            <html>

            <head>
                <meta name='viewport' content='width=device-width, initial-scale=1.0' />
            </head>

            <body>
                <div>
                    <div>
                        <div>
                            <div>
                                <h4 style='text-align: center'>". $datFact['Empresa'] ."</h4>
                                <h5 style='text-align: center'>". $datFact['razonSocial'] ."<br>
                                    ". $datFact['direccion'] ."<br>
                                    ". $datFact['NIT'] ."</h5>
                            </div>
                            <div>
                                <h6 style='text-align: center'>". $datFact['tipoAfiliacion'] ."<br><br>
                                    DOCUMENTO ELECTRONICO <br>
                                    " . $datFact['leyendaFEL'] . "<br>
                                    Numero Autorizacion: <br>
                                    " . $datFact['AutorizacionFEL'] . "<br>
                                    Fecha Certificacion:
                                    " . $datFact['FechaEmisionFEL'] . "<br>
                                    DIGIFACT, S.A. | NIT: 77454820
                                </h6>
                            </div>

                            <div>
                                <h6 style='margin-left: 18%;'>Serie: " . $datFact['serie'] . "<br>
                                    Numero: " . $datFact['correlativo'] . "<br>
                                    Fecha Emision: " . $datFact['FechaFactura'] . "<br>
                                    NIT: " . $datFact['nitCliente'] . "<br>
                                    Nombre: " . $datFact['nombreCliente'] . "<br>
                                    Direccion: " . $datFact['direccionCliente'] . "<br>
                                </h6>
                            </div>
                        </div>
                    </div>
                    <div>
                        <div>
                            <div>
                                <h5 style='text-align: center'>- DETALLE POR PRODUCTO -</h5>
                            </div>
                            <div>
                                <table style='font-size: 12px;margin-left: auto; margin-right: auto;'>
                                    <tr>
                                        <th
                                            style='border-bottom: 1px solid black; padding-right: 10px; padding-left: 10px; text-align: right; width: 16%;'>
                                            <b>CANT.</b>
                                        </th>
                                        <th
                                            style='border-bottom: 1px solid black; padding-right: 10px; padding-left: 10px; text-align: left; width: 50%;'>
                                            <b>DESCRIPCION.</b>
                                        </th>
                                        <th
                                            style='border-bottom: 1px solid black; padding-right: 10px; padding-left: 10px; text-align: right; width: 16%;'>
                                            <b>PRECIO.</b>
                                        </th>
                                        <th
                                            style='border-bottom: 1px solid black; padding-right: 10px; padding-left: 10px; text-align: right; width: 16%;'>
                                            <b>TOTAL.</b>
                                        </th>
                                    </tr>
                                    <tr>
                                        <td style='padding-right: 10px; padding-left: 5px; text-align: right;'>
                                            " . $cant . " <br>
                                        </td>
                                        <td style='padding-right: 10px; padding-left: 10px; text-align: left;'>
                                            " . $nombre . " <br>
                                        </td>
                                        <td style='padding-right: 10px; padding-left: 10px; text-align: right;'>
                                            " . $precio . " <br>
                                        </td>
                                        <td style='padding-right: 10px; padding-left: 5px; text-align: right;'>
                                            " . $total . " <br>
                                        </td>
                                    </tr>
                                </table>
                            </div>
                            <div style='text-align: center;'>
                                <h5>- TOTAL: Q". $datFact['total'] ." -</h5>
                                Powered by Proper <br>
                                www.somosproper.com
                            </div>
                        </div>
                    </div>
                </div>
            </body>
            </html>";

        // * Renderiza el HTML
        $this->mpdf->WriteHTML($this->renderHTML_test);

        // * Genera nombre del pdf
        $nombrePdf = "Factura_" . $datFact["Empresa"] . "_" . $datFact['serie'] . ".pdf";

        // * Salida de un archivo PDF directamente a la pestaña del navegador
        $this->mpdf->Output("pdfs/" . $nombrePdf);

      
    	// ! SENDGRID
        $sqlS = "SELECT valor FROM empresaConfig WHERE opcion = 'apiKey' AND idEmpresas = " . $params['idEmpresas'] . ";";
        $queryS = mysql_query($sqlS, dbCon::con($params['dbName']));
        $regS = mysql_fetch_assoc($queryS);
        // ! SENDGRID
        // * Crea objeto de SendGrid y le envía el API Key como parametro al constructor
        $sendgrid = new \SendGrid( $regS['valor']);

        // * Crea objeto de Mail()
        $this->email = new \SendGrid\Mail\Mail();
        // * Se asignanr parametros a las funciones de Mail()
    	$this->email->setFrom("consola@somosproper.com", "Proper Shop");
        $this->email->setSubject("Factura " . $datFact["Empresa"] . " " . $fechaHora);
        $this->email->addTo($params["email"], $datFact["Empresa"]);
        $this->email->addContent(
            "text/plain",
            "Factura por correo electrónico"
        );

        // * Codificacion de archivo generado en carpeta 'pdfs/.$nombrePdf'
        $file_encoded = base64_encode(file_get_contents("pdfs/" . $nombrePdf));

        // * Se adjunta el pdf creado al email
        $this->email->addAttachment(
            $file_encoded,
            "application/pdf",
            $nombrePdf,
            "attachment"
        );

        // *  Intento de envío
        try {
            $response = $sendgrid->send($this->email);
            //print 'Email sent successfuly' . "\n";
            //print 'Status Code: ' . $response->statusCode() . "\n";
        	print $response->statusCode();
        } catch (Exception $e) {
            echo 'Caught exception: ' .  $e->getMessage() . "\n";
        }
        
    	unlink("pdfs/" . $nombrePdf);
    
    }


    // sendgrid api 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
}

