<?php

require_once "../libs/vendor/autoload.php";

class reporteCierrePDF
{
    // * Variables globales para mPDF
    public $mpdf;
    public $htmlFile;
    public $renderHTML_test;

    // * Variables globales para SendGrid
    public $email;
    // Subrutina para generar el reporte con los datos del $response[]
    public function generarReporteCierrePDF($params)
    {
        // ! Establece la zona horaria por defecto.
        date_default_timezone_set('America/Guatemala');

        // ! Creación de fecha y hora
        $fechaHora = date("Y-m-d-H-i-s");

        // ! Ajuste de parametros
        // * Matriz $detalleVentas para recorrer
        $detalleVentas = $params['detalleVentas'];
        // * Variables a asignar el Detalle de Venta
        $sku = "";
        $nombre = "";
        $cant = "";
        $total = "";

        foreach ($detalleVentas as $index => $value) {
            if (is_array($value)) {
                foreach ($value as $key => $values) {
                    echo $key . " : " . $values . "<br>";
                    if ($key == "sku") {
                        $sku .= $values  . '<br>';
                    }
                    if ($key == "nombre") {
                        $nombre .= $values  . '<br>';
                    }
                    if ($key == "cant") {
                        $cant .= $values  . '<br>';
                    }
                    if ($key == "descuento") {
                        $desc .= $values  . '<br>';
                    }
                    if ($key == "total") {
                        $total .= "Q " . $values  . '<br>';
                    }
                }
            }
        }
        // $keys = array_keys($detalleVentas);
        // for ($i = 0; $i < count($detalleVentas); $i++) {
        //     echo $keys[$i] . "<br>";

        //     foreach ($detalleVentas[$keys[$i]] as $key => $value) {
        //         echo $key . " : " . $value . "<br>";
        //     }
        // }

        // * Valida si hay diferencia

        if ($params['diferencia'] == "0.00" || $params['diferencia'] == "") {
            $diferencia = "";
        } else {
            $diferencia = "<p style='text-align: center'>DIFERENCIA: Q " . $params['diferencia'] . "</p>";
        }

        // ! MPDF
        // * Crea una instancia de la clase Mpdf:
        $this->mpdf = new \Mpdf\Mpdf();

        // * Renderizado del html.
        $this->renderHTML_test = "
            <!DOCTYPE html>
            <html lang='es'>
                <head>
                    <meta charset='UTF-8' />
                    <meta name='viewport' content='width=device-width, initial-scale=1.0' />
                    <style>       
                    body {
                        font-family: Calibri, sans-serif;
                    }
                    </style>
                    <title>Reporte Cierre</title>
                </head>
            
                <body>
                    <div>
                        <div>
                            <div>
                                <div>
                                    <h1 style='text-align: center'>Corte de caja</h1>
                                    <h2 style='text-align: center'>" . $params['nombreEmpresa'] . "</h2>
                                </div>
                                <div>
                                    <p style='margin-bottom: 0px; padding-bottom: 0px; text-align: center; font-size: 14rpx'>Usuario: " . $params['nombreUsuario'] . "</p>
                                    <p style='margin-bottom: 0px; padding-bottom: 0px; text-align: center; font-size: 12rpx'>APERTURA: " . $params['fecIniFondo'] . "</p>
                                    <p style='text-align: center; font-size: 12rpx'>CIERRE: " . $params['fecFinFondo'] . "</p>
                                </div>                             
                                <div style='margin: 0% 0% 0% 35%; width: 40%;'>
                                    <table>
                                        <tr>
                                            <td>FONDO CAJA: </td>
                                            <td>Q " . $params['montoFondo'] . "</td>               
                                        </tr>
                                        <tr>
                                            <td>VALES: </td>
                                            <td>Q " . $params['totalVales'] . "</td>               
                                        </tr>
                                        <tr>
                                            <td>VISA: </td>
                                            <td>Q " . $params['totalVisa'] . "</td>               
                                        </tr>
                                        <tr>
                                            <td>CREDOMATIC: </td>
                                            <td>Q " . $params['totalBac'] . "</td>               
                                        </tr>
                                        <tr>
                                            <td>EFECTIVO: </td>
                                            <td>Q " . $params['totalEfectivoQ'] . "</td>               
                                        </tr>
                                        <tr>
                                            <td>DESCUENTOS: </td>
                                            <td>Q " . $params['totalDescuento'] . "</td>               
                                        </tr>
                                    </table>
                                </div>
                                <div>
                                    <h2 style='text-align: center'>VENTA NETA: Q " . $params['totalVentas'] . "</h2>
                                        " . $diferencia . "
                                </div>
                            </div>
                        </div>
                        <div>
                            <div>
                                <div>
                                    <h3 style='text-align: center'>- DETALLE POR PRODUCTO -</h3>
                                </div>
                                <div style='margin: 0% 0% 0% 0%; width: 117%;'>                                
                                    <table style='font-size: 12px;'>
                                        <tr>
                                            <th style='border-bottom: 1px solid black; padding-right: 10px; padding-left: 10px; text-align: right; width: 20%;'>
                                                <b>SKU</b>
                                            </th>
                                            <th style='border-bottom: 1px solid black; padding-right: 10px; padding-left: 10px; text-align: left; width: 65%;'>
                                                <b>DESCRIPCIÓN</b> 
                                            </th>                                            
                                            <th style='border-bottom: 1px solid black; padding-right: 10px; padding-left: 10px; text-align: right; width: 16%;'>
                                                <b>CANT.</b> 
                                            </th>
                                            <th style='border-bottom: 1px solid black; padding-right: 10px; padding-left: 10px; text-align: right; width: 16%;'>
                                                <b>DESCUENTO</b> 
                                            </th>
                                            <th style='border-bottom: 1px solid black; padding-right: 10px; padding-left: 10px; text-align: right; width: 16%;'>
                                                <b>TOTAL</b> 
                                            </th>
                                        </tr>
                                        <tr>
                                            <td style='padding-right: 10px; padding-left: 0px; text-align: right;'>
                                                " . $sku . " <br>
                                            </td>
                                            <td style='padding-right: 10px; padding-left: 10px; text-align: left;'>
                                                " . $nombre . " <br>
                                            </td>
                                            <td style='padding-right: 10px; padding-left: 5px; text-align: right;'>
                                                " . $cant . " <br>
                                            </td>
                                            <td style='padding-right: 10px; padding-left: 5px; text-align: right;'>
                                                " . $desc . " <br>
                                            </td>
                                            <td style='padding-right: 10px; padding-left: 5px; text-align: right;'>
                                                " . $total . " <br>
                                            </td>
                                        </tr>
                                    </table>
                                </div>
                            </div>
                        </div>
                    </div>
                </body>
            </html>
        ";

        // * Renderiza el HTML
        $this->mpdf->WriteHTML($this->renderHTML_test);

        // * Genera nombre del pdf
        $nombrePdf = "reporte_cierre_" . $params['nombreEmpresa'] . "_" . $fechaHora . ".pdf";

        // * Salida de un archivo PDF directamente a la pestaña del navegador
        $this->mpdf->Output("pdfs/" . $nombrePdf);
    
    	//obtener el id de la empresa

		// ! SENDGRID
        $sqlS = "SELECT valor FROM empresaConfig WHERE opcion = 'apiKey';";
        $queryS = mysql_query($sqlS, dbCon::con($params['dbName']));
        $regS = mysql_fetch_assoc($queryS);
        // * Crea objeto de SendGrid y le envía el API Key como parametro al constructor
        $sendgrid = new \SendGrid( $regS['valor']);
    
        // * Crea objeto de Mail()
        $this->email = new \SendGrid\Mail\Mail();
        // * Se asignanr parametros a las funciones de Mail()
    	$this->email->setFrom("consola@somosproper.com", "Proper Shop");
        $this->email->setSubject("Reporte de cierre " . $params['nombreEmpresa'] . "_" . $fechaHora);
        $this->email->addTo($params['email'], $params['nombreEmpresa']);
        $this->email->addContent(
            "text/plain",
            "Reporte"
        );

        // * Codificacion de archivo generado en carpeta 'pdfs/.$nombrePdf'
        $file_encoded = base64_encode(file_get_contents("pdfs/" . $nombrePdf));

        // * Se adjunta el pdf creado al email
        $this->email->addAttachment(
            $file_encoded,
            "application/pdf",
            $nombrePdf,
            "attachment"
        );

        // *  Intento de envío
        try {
            $response = $sendgrid->send($this->email);
            print 'Email sent successfuly' . "\n";
            print 'Status Code: ' . $response->statusCode() . "\n";
        } catch (Exception $e) {
            echo 'Caught exception: ' .  $e->getMessage() . "\n";
        }
    }

    // sendgrid api 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
}
