<?php

date_default_timezone_set("America/Guatemala");
header('Access-Control-Allow-Origin: *');
header('Content-Type: text/html; charset=utf-8');
require_once("../clases/general.php");
require_once("../clases/inventarios.php");
require_once("../clases/reporteCierrePDF.php");
require_once("../clases/reporteTransac.php");
require_once("../clases/facturaPDF.php");
require_once("../clases/NumberToLetterConverter.class.php");
$general = new General();
$inventario = new inventarios();
$repCierre = new reporteCierrePDF();
$repTransac = new reporteTransac();
$facPDF = new facturaPDF();
$converter = new NumberToLetterConverter();
$service = $_REQUEST['service'];
switch ($service) {
	case 'getAppConfig':
		$data = $general->getAppConfig($_REQUEST);
		echo json_encode($data);
		break;
    case 'login':
        $login = $general->login($_REQUEST);
        echo json_encode($login);
        break; 
    case 'getCategorias':
        $data = $general->getCategorias($_REQUEST);
        echo json_encode($data);
        break;
    case 'getProductosCategorias':
        $data = $general->getProductosCategorias($_REQUEST);
        echo json_encode($data);
        break;
	case 'getProductos':
        $data = $general->getProductos($_REQUEST);
        echo json_encode($data);
        break;
	case 'getProductos2':
        $data = $general->getProductos2($_REQUEST);
        echo json_encode($data);
        break;
	case 'getProductosBuscador':
        $data = $general->getProductosBuscador($_REQUEST);
        echo json_encode($data);
        break;
    case 'agregarProductoVenta':
        $data = $general->agregarProductoVenta($_REQUEST);
        echo json_encode($data);
        break;
    case 'getIdProducto':
        $data = $general->getIdProducto($_REQUEST);
        echo json_encode($data);
        break;
    case 'loadProductosVenta':
        $data = $general->loadProductosVenta($_REQUEST);
        echo json_encode($data);
        break;
    case 'cancelarVenta':
        $data = $general->cancelarVenta($_REQUEST);
        echo json_encode($data);
        break;
    case 'eliminarProductoVenta':
        $data = $general->eliminarProductoVenta($_REQUEST);
        echo json_encode($data);
        break;
    case 'finalizarVenta':
        $number = explode(".", $_REQUEST['totalFactura']);
       
		if (count($number) == 1){
        	$decimals = '0';
        } else {
        	 $decimals = $number[1];
        }
      	if (strlen($number[1]) === 1) {
            $decimals = $number[1] . '0';
        } 
		
        $_REQUEST['totalEnLetras'] = $converter->to_word($number[0]) . 'QUETZALES CON ' . $converter->to_word($decimals) . 'CENTAVOS.';
        $process = $general->finalizarVenta($_REQUEST);
        echo json_encode($process);
        break;
	case 'finalizarVentaCambiaria':

		$number = explode(".", $_REQUEST['total']);
       
		if (count($number) == 1){
        	$decimals = '0';
        } else {
        	 $decimals = $number[1];
        }
      	if (strlen($number[1]) === 1) {
            $decimals = $number[1] . '0';
        } 
		
        $_REQUEST['totalEnLetras'] = $converter->to_word($number[0]) . 'QUETZALES CON ' . $converter->to_word($decimals) . 'CENTAVOS.';
        $process = $general->finalizarVentaCambiaria($_REQUEST);
        echo json_encode($process);
		break;
    case 'getDocumentoFacturacion':
        $data = $general->getDocumentoFacturacion($_REQUEST);
        echo json_encode($data);
        break;
    case 'getDocumentoAbono':
        $data = $general->getDocumentoAbono($_REQUEST);
        echo json_encode($data);
        break;
    case 'consultaNIT':
        $data = $general->consultaNIT($_REQUEST);
        echo json_encode($data);
        break;
    case 'generarFormatoFEL':
        $process = $general->generarFormatoFEL($_REQUEST);
        echo json_encode($process);
        break;
    case 'fondoCaja':
        $data = $general->getFondoCaja($_REQUEST);
        echo json_encode($data);
        break;
    case 'aperturarCaja':
        $data = $general->aperturarCaja($_REQUEST);
        echo json_encode($data);
        break;
    case 'transacciones':
        $data = $general->transacciones($_REQUEST);
        echo json_encode($data);
        break;
    case 'lecturaCaja':
        $data = $general->lecturaCaja($_REQUEST);
        echo json_encode($data);
        break;
    case 'registrarVale':
        $process = $general->registrarVale($_REQUEST);
        echo json_encode($process);
        break;
    case 'procesarCorte':
        $data = $general->procesarCorte($_REQUEST);
        echo json_encode($data);
        break;
    case 'liquidacionVenta':
        $process = $general->liquidacionVenta($_REQUEST);
        echo json_encode($process);
        break;
    case 'getDetalleVentas':
        $data = $general->getDetalleVentas($_REQUEST);
        echo json_encode($data);
        break;
	case 'getDatosReporte':
        $data = $general->getDatosReporte($_REQUEST);
        echo json_encode($data);
        break;
    // * Caso reporteCierre
    case 'reporteCierre':
        $repCierre->generarReporteCierrePDF($_REQUEST);
        // $data = $repCierre->generarReporteCierrePDF($_REQUEST);
        // echo json_encode($data);
        break;
	case 'anulacionFactura':
		$data = $general->anulacionFactura($_REQUEST);
		echo json_encode($data);
		break;
	case 'aplicarDescuento':
		$data = $general->aplicarDescuento($_REQUEST);
		echo json_encode($data);
		break;
	case 'opcionesProducto':
		$data = $general->opcionesProducto($_REQUEST);
		echo json_encode($data);
		break;
	case 'guardarOpciones':
		$data = $general->guardarOpciones($_REQUEST);
		echo json_encode($data);
		break;
	case 'getCajeros':
		$data = $general->getCajeros($_REQUEST);
		echo json_encode($data);
		break;
	case 'getVendedores':
		$data = $general->getVendedores($_REQUEST);
		echo json_encode($data);
		break;
	case 'getMaquinas':
		$data = $general->getMaquinas($_REQUEST);
		echo json_encode($data);
		break;
	case 'getAerolineas':
		$data = $general->getAerolineas($_REQUEST);
		echo json_encode($data);
		break;
	case 'agregarVentasATO':
		$data = $general->agregarVentasATO($_REQUEST);
		echo json_encode($data);
		break;
	case 'getResumen':
		$data = $general->getResumen($_REQUEST);
		echo json_encode($data);
		break;
    case 'reporteTransac':
        $repTransac->generarReporteTransac($_REQUEST);
        break;
	case 'facturaPDF':
        $facPDF->generarFacturaPDF($_REQUEST);
        break;
	case 'guardarDatosEnvio':
	$data = $general->guardarDatosEnvio($_REQUEST);
		echo json_encode($data);
		break;
	case 'guardarDetCambios':
	$data = $general->guardarDetCambios($_REQUEST);
		echo json_encode($data);
		break;
	case 'printFacturaEnvioHeader':
	$data = $general->printFacturaEnvioHeader($_REQUEST);
		echo json_encode($data);
		break;
	case 'printFacturaEnvioDetail':
	$data = $general->printFacturaEnvioDetail($_REQUEST);
		echo json_encode($data);
		break;
	case 'getDatosProducto':
	$data = $general->getDatosProducto($_REQUEST);
		echo json_encode($data);
		break;
	case 'getTransportistas':
	$data = $general->getTransportistas($_REQUEST);
		echo json_encode($data);
		break;
	case 'consultaCliente':
	$data = $general->consultaCliente($_REQUEST);
		echo json_encode($data);
		break;
	case 'getDatosCliente':
        $data = $general->getDatosCliente($_REQUEST);
        echo json_encode($data);
        break;
	case 'reprintFactHeader':
	$data = $general->reprintFactHeader($_REQUEST);
		echo json_encode($data);
		break;
	case 'reprintFactDetail':
	$data = $general->reprintFactDetail($_REQUEST);
		echo json_encode($data);
		break;
	case 'getZonas':
	$data = $general->getZonas($_REQUEST);
		echo json_encode($data);
		break;
	case 'getBancos':
	$data = $general->getBancos($_REQUEST);
		echo json_encode($data);
		break;
	case 'getPrecios':
	$data = $general->getPrecios($_REQUEST);
		echo json_encode($data);
		break;
	case 'empresaActual':
	$data = $general->empresaActual($_REQUEST);
		echo json_encode($data);
		break;
	case 'getEmpresas':
	$data = $general->getEmpresas($_REQUEST);
		echo json_encode($data);
		break;
	case 'getSaldoCliente':
	$data = $general->getSaldoCliente($_REQUEST);
		echo json_encode($data);
		break;
	case 'guardarSaldo':
	$data = $general->guardarSaldo($_REQUEST);
		echo json_encode($data);
		break;
	case 'getClientes':
	$data = $general->getClientes($_REQUEST);
		echo json_encode($data);
		break;
	case 'listaCreditos':
	$data = $general->listaCreditos($_REQUEST);
		echo json_encode($data);
		break;
	case 'creditosCliente':
	$data = $general->creditosCliente($_REQUEST);
		echo json_encode($data);
		break;
	case 'guardarAbono':
	$data = $general->guardarAbono($_REQUEST);
		echo json_encode($data);
		break;
	case 'abonosCliente':
	$data = $general->abonosCliente($_REQUEST);
		echo json_encode($data);
		break;
	case 'datosAbono':
	$data = $general->datosAbono($_REQUEST);
		echo json_encode($data);
		break;
	case 'getCategoriaPrecio':
	$data = $general->getCategoriaPrecio($_REQUEST);
		echo json_encode($data);
		break;
	case 'eliminarCarrito':
	$data = $general->eliminarCarrito($_REQUEST);
		echo json_encode($data);
		break;
    case 'getCorrelativoInterno':
        $data = $general->getCorrelativoInterno($_REQUEST);
        echo json_encode($data);
        break;
	case 'listaEnvios':
        $data = $general->listaEnvios($_REQUEST);
        echo json_encode($data);
        break;
	case 'clientesCobrador':
        $data = $general->clientesCobrador($_REQUEST);
        echo json_encode($data);
        break;
	case 'serviciosGeneral':
        $data = $general->serviciosGeneral($_REQUEST);
        echo json_encode($data);
        break;
	case 'agregarServicioVenta':
        $data = $general->agregarServicioVenta($_REQUEST);
        echo json_encode($data);
        break;
	case 'saldosCliente':
        $data = $general->saldosCliente($_REQUEST);
        echo json_encode($data);
        break;
	case 'serviciosVendidos':
        $data = $general->serviciosVendidos($_REQUEST);
        echo json_encode($data);
        break;
	case 'saldoServicio':
        $data = $general->saldoServicio($_REQUEST);
        echo json_encode($data);
        break;
	case 'saldoGlobal':
        $data = $general->saldoGlobal($_REQUEST);
        echo json_encode($data);
        break;
	case 'agregarCuentaCorriente':
        $data = $general->agregarCuentaCorriente($_REQUEST);
        echo json_encode($data);
        break;
	case 'getDatosCargo':
        $data = $general->getDatosCargo($_REQUEST);
        echo json_encode($data);
        break;
	case 'getProductosServicio':
        $data = $general->getProductosServicio($_REQUEST);
        echo json_encode($data);
        break;
	case 'resumenCorte':
        $data = $general->resumenCorte($_REQUEST);
        echo json_encode($data);
        break;
	case 'getDocumentoRecibo':
        $data = $general->getDocumentoRecibo($_REQUEST);
        echo json_encode($data);
        break;
	case 'getServicios':
        $data = $general->getServicios($_REQUEST);
        echo json_encode($data);
        break;
	case 'setServicioCliente':
        $data = $general->setServicioCliente($_REQUEST);
        echo json_encode($data);
        break;
	case 'editarSerieProducto':
        $data = $general->editarSerieProducto($_REQUEST);
        echo json_encode($data);
        break;
	case 'getExistencias':
        $data = $general->getExistencias($_REQUEST);
        echo json_encode($data);
        break;
	case 'getBodegas':
		$data = $inventario->getBodegas($_REQUEST);
		echo json_encode($data);
		break;
	case 'getSucursales':
		$data = $inventario->getSucursales($_REQUEST);
		echo json_encode($data);
		break;
	case 'getBodySuc':
		$data = $inventario->getBodySuc($_REQUEST);
		echo json_encode($data);
		break;
	case 'getUsuarios':
		$data = $inventario->getUsuarios($_REQUEST);
		echo json_encode($data);
		break;
	case 'getAjustes':
		$data = $inventario->getAjustes($_REQUEST);
		echo json_encode($data);
		break;
    case 'iniciarAjuste':
		$data = $inventario->iniciarAjuste($_REQUEST);
		echo json_encode($data);
		break;
	case 'agregarProductoAjuste':
		$data = $inventario->agregarProductoAjuste($_REQUEST);
		echo json_encode($data);
		break;
	case 'loadProductosAjuste':
		$data = $inventario->loadProductosAjuste($_REQUEST);
		echo json_encode($data);
		break;
	case 'trasladarAjuste':
		$data = $inventario->trasladarAjuste($_REQUEST);
		echo json_encode($data);
		break;
	case 'getAjuste':
		$data = $inventario->getAjuste($_REQUEST);
		echo json_encode($data);
		break;
    case 'updateAjuste':
		$data = $inventario->updateAjuste($_REQUEST);
		echo json_encode($data);
		break;
	case 'deleteAjuste':
		$data = $inventario->deleteAjuste($_REQUEST);
		echo json_encode($data);
		break;
	case 'deleteProductoAjuste':
		$data = $inventario->deleteProductoAjuste($_REQUEST);
		echo json_encode($data);
		break;
	case 'movimientoInventario':
		$data = $inventario->movimientoInventario($_REQUEST);
		echo json_encode($data);
		break;
	case 'verificarTransferencia':
		$data = $inventario->verificarTransferencia($_REQUEST);
		echo json_encode($data);
		break;


}
